/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-03-17 at 03:58:05 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.clouderrorreporting.v1beta1.model;

/**
 * Describes a running service that sends errors. Its version changes over time and multiple
 * versions can run in parallel.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Error Reporting API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ServiceContext extends com.google.api.client.json.GenericJson {

  /**
   * Type of the MonitoredResource. List of possible values:
   * https://cloud.google.com/monitoring/api/resources
   *
   * Value is set automatically for incoming errors and must not be set when reporting errors.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String resourceType;

  /**
   * An identifier of the service, such as the name of the executable, job, or Google App Engine
   * service name. This field is expected to have a low number of values that are relatively stable
   * over time, as opposed to `version`, which can be changed whenever new code is deployed.
   *
   * Contains the service name for error reports extracted from Google App Engine logs or `default`
   * if the App Engine default service is used.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String service;

  /**
   * Represents the source code version that the developer provided, which could represent a version
   * label or a Git SHA-1 hash, for example. For App Engine standard environment, the version is set
   * to the version of the app.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String version;

  /**
   * Type of the MonitoredResource. List of possible values:
   * https://cloud.google.com/monitoring/api/resources
   *
   * Value is set automatically for incoming errors and must not be set when reporting errors.
   * @return value or {@code null} for none
   */
  public java.lang.String getResourceType() {
    return resourceType;
  }

  /**
   * Type of the MonitoredResource. List of possible values:
   * https://cloud.google.com/monitoring/api/resources
   *
   * Value is set automatically for incoming errors and must not be set when reporting errors.
   * @param resourceType resourceType or {@code null} for none
   */
  public ServiceContext setResourceType(java.lang.String resourceType) {
    this.resourceType = resourceType;
    return this;
  }

  /**
   * An identifier of the service, such as the name of the executable, job, or Google App Engine
   * service name. This field is expected to have a low number of values that are relatively stable
   * over time, as opposed to `version`, which can be changed whenever new code is deployed.
   *
   * Contains the service name for error reports extracted from Google App Engine logs or `default`
   * if the App Engine default service is used.
   * @return value or {@code null} for none
   */
  public java.lang.String getService() {
    return service;
  }

  /**
   * An identifier of the service, such as the name of the executable, job, or Google App Engine
   * service name. This field is expected to have a low number of values that are relatively stable
   * over time, as opposed to `version`, which can be changed whenever new code is deployed.
   *
   * Contains the service name for error reports extracted from Google App Engine logs or `default`
   * if the App Engine default service is used.
   * @param service service or {@code null} for none
   */
  public ServiceContext setService(java.lang.String service) {
    this.service = service;
    return this;
  }

  /**
   * Represents the source code version that the developer provided, which could represent a version
   * label or a Git SHA-1 hash, for example. For App Engine standard environment, the version is set
   * to the version of the app.
   * @return value or {@code null} for none
   */
  public java.lang.String getVersion() {
    return version;
  }

  /**
   * Represents the source code version that the developer provided, which could represent a version
   * label or a Git SHA-1 hash, for example. For App Engine standard environment, the version is set
   * to the version of the app.
   * @param version version or {@code null} for none
   */
  public ServiceContext setVersion(java.lang.String version) {
    this.version = version;
    return this;
  }

  @Override
  public ServiceContext set(String fieldName, Object value) {
    return (ServiceContext) super.set(fieldName, value);
  }

  @Override
  public ServiceContext clone() {
    return (ServiceContext) super.clone();
  }

}
